#!/usr/bin/perl

#    Copyright (C) 2009-2015 Craciun Dan <floydian.embryo@yahoo.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#    XPTB Lite 0.2.4 (eXtended Perl Trivia Bot Lite)
#    A basic, fast-paced trivia bot for IRC made in Perl.
#    For the latest release visit the homepage:
#
#    http://www.tuxarena.com/intro/xptb.php
#
#    Old homepage (SourceForge):
#
#    http://xptb.sourceforge.net/

use Net::IRC;

my $irc = new Net::IRC;

get_cfg ();

my $conn = $irc -> newconn
    (
     Server => shift || "$glob_server",
     Port => shift || "$glob_port",
     Nick => shift || "$glob_nick",
     Ircname => "$glob_ircname",
     Username => "$glob_username"
    );

$conn -> {channel} = shift || "$glob_channel";

$status = 'send_question';

sub on_connect
{
    my $conn = shift;

    $conn -> join ($conn -> {channel});
    $conn -> {connected} = 1;
    $elapsed = time;
    $init_time = $elapsed;
    $status = 'send_question';
    $time_of_msgs = time;
    $count_msgs = 0;
    print "Connected. Trivia has started on channel " . $conn -> {channel} . "...\n"
}

# End of MotD is marked by 376
$conn -> add_handler ('376', \&on_connect);

sub main_loop
{
    my $conn = shift;
    if ($status =~ /^keep_counting$/)
    {
	$seconds = $elapsed - $init_time;
	if ($seconds < 15)
	{
	    $elapsed = $elapsed + 1;
	}
	elsif ($seconds >= 15 && $seconds < 22)
	{
	    $elapsed = $elapsed + 1;
	    if ($seconds == 15)
	    {
		$answered = 1;
		$conn -> privmsg ($conn -> {channel}, "\00302,00Time is up! The answer was: \00304,00$orig_val\00302,00. Next question in 5 seconds.");
	    }

	}
	elsif ($seconds >= 22)
	{
	    $seconds = 0;
	    $status = 'send_question';
	}
    }
    if ($status =~ /^send_question$/)
    {
	$time_of_question = `date +"%s.%N"`;
	# chop ($time_of_question); # remove the newline character, not necessary since we
	# only need the first 14 characters
	$time_of_question = substr ($time_of_question, 0, 14); # only 3 decimals
	$init_time = time;
	if (get_question () == 1) # $opt holds the question, $val holds the answer
	{
	    $conn -> privmsg ($conn -> {channel}, "\00300,04No questions found. Quiting...");
	    print "ERROR: Questions file not found. Make sure the file questions.txt is in the same directory with this script.\n";
	    exit;
	}
	else
	{
	    if ($array_length == 1) # check to see if the answer is one word, or more words
	    {
		$conn -> privmsg ($conn -> {channel}, "\00300,02$opt\00314,00 [$array_length word]"); # send question to channel
		$conn -> privmsg ($conn -> {channel}, "\00302,00Hint 1:\00304,00 $hint_a");
				#$conn -> privmsg ($conn -> {channel}, "\00302,00Hint 2:\00304,00 $hint_b");
		$time_last_hint = time;
		$elapsed = $init_time;
		$status = 'keep_counting';
		$answered = 0;
	    }
	    elsif ($array_length > 1)
	    {
		$conn -> privmsg ($conn -> {channel}, "\00300,02$opt\00314,00 [$array_length words]");
		$conn -> privmsg ($conn -> {channel}, "\00302,00Hint 1:\00304,00 $hint_a");
				#$conn -> privmsg ($conn -> {channel}, "\00302,00Hint 2:\00304,00 $hint_b");
		$time_last_hint = time;
		$elapsed = $init_time;
		$status = 'keep_counting';
		$answered = 0;
	    }
	    else
	    {
		$conn -> privmsg ($conn -> {channel}, "\00300,04Error parsing the answer, skipping to the next question.");
		print "ERROR: Error parsing the answer, check the questions.txt file. Each line should have the form QUESTION|ANSWER.\n";
		$elapsed = $init_time;
	    }
	    #$elapsed = $init_time;
	    #$status = 'keep_counting';
	}
    }
    if ($status =~ /^answered$/)
    {
	$seconds2 = $elapsed2 - $init_time2;
	if ($seconds2 < 5)
	{
	    $elapsed2 = $elapsed2 + 1;
	}
	elsif ($seconds2 >= 5 && $seconds2 < 10)
	{
	    if ($seconds2 == 5)
	    {
		$conn -> privmsg ($conn -> {channel}, "\00302,00The answer was: \00304,00$orig_val\00302,00. Next question in 5 seconds.");
	    }
	    $elapsed2 = $elapsed2 + 1;
	}
	elsif ($seconds2 >= 10)
	{
	    $seconds2 = 0;
	    $status = 'send_question';
	}
    }
}

sub get_question
{
    my $conn = shift;
    count_lines ();
    $val_open = open (QF, "questions.txt");
    $random = int (rand ($lines - 1));
    $count = 0;
    if ($val_open == 1)
    {
	while (<QF>)
	{
	    if ($count == $random)
	    {
		@array = split ('\|', $_);
		$opt = $array[0]; # holds the question
		$val = $array[1]; # holds the answer
		chop ($val);
		$orig_val = $val;
		@array_val = split (' ', $orig_val);
		$array_length = @array_val; # $array_length will hold the number of words the answer has
		$k = 0;
		$hint_a = ""; $ha = 0;
		$hint_b = ""; $hb = 0;
		while ($k < $array_length)
		{
		    $len_of_word = length ($array_val[$k]); # length of a word in the answer
		    $k_len = 0;
		    while ($k_len < $len_of_word)
		    {
			if ($k_len == 0)
			{
			    $char_a = substr ($array_val[$k], 0, 1);
			    $hint_b = $hint_b . $char_a;
			}
			elsif ($k_len == $len_of_word - 1)
			{
			    $char_a = substr ($array_val[$k], -1);
			    $hint_b = $hint_b . $char_a;
			}
			else
			{
			    $hint_b = $hint_b . "*"; $hb = 1;
			}
			$hint_a = $hint_a . "*"; $ha = 1;
			$k_len = $k_len + 1;
		    }
		    if ($k < $array_length - 1)
		    {
			$hint_a = $hint_a . " ";
			$hint_b = $hint_b . " ";
		    }
		    $k = $k + 1;
		}
		$val = lc ($val);
		$len = length ($val);
		close (QF);
		return 0; # we got our question and answer, return 0 for success
	    }
	    else
	    {
		$count = $count + 1;
	    }
	}
	close (QF);
    }
    else
    {
	return 1; # questions.txt file not found, return 1 for error
    }
    close (QF);
    return 1; # some other error (shouldn't get here though)
}

# subroutine to process every message on the channel, commands and answers
sub on_public
{
    my ($conn, $event) = @_;
    my $text = $event -> {args}[0];
    my $nick = $event -> {nick};
    lc ($text);
    # TODO: how to ignore only one nick, letting others still use the command
    if ($text =~ /^!trivia$/ || $text =~ /^!version$/)
    {
	$conn->privmsg ($conn->{channel}, "\00300,03XPTB Lite 0.2.4 by Craciun Dan - http://www.tuxarena.com/intro/xptb.php");
    }
    if ($text =~ /^!questions$/)
    {
	$conn -> privmsg ($conn -> {channel}, "\00300,03There are $lines questions available.");
    }
    if ($text =~ /^!next$/)
    {
	$conn -> privmsg ($conn -> {channel}, "\00300,03Jumping to the next question.");
	$init_time2 = time;
	$elapsed2 = $init_time2;
	$status = 'send_question';
	$answered = 1;
    }
    if ($text =~ /^!date$/)
    {
	show_date ();
	$conn -> privmsg ($conn -> {channel}, "\00300,03Current system date and time: $var_date");
    }
    if ($status =~ /^keep_counting$/)
    {
	if ("$text" =~ /$val/ && $answered == 0)
	{
	    $time_of_answer = `date +"%s.%n"`;
	    $time_of_answer = substr ($time_of_answer, 0, 14);
	    $secs = $time_of_answer - $time_of_question;
	    $cps = $len / $secs;
	    if ($secs < 10)
	    {
		$secs = substr ($secs, 0, 4);
	    }
	    elsif ($secs >= 10 && $secs < 100)
	    {
		$secs = substr ($secs, 0, 5);
	    }
	    if ($cps < 10)
	    {
		$cps = substr ($cps, 0, 4);
	    }
	    elsif ($cps >= 10 && $cps < 100)
	    {
		$cps = substr ($cps, 0, 5);
	    }
	    $conn -> privmsg ($conn -> {channel}, "\00303,00You got it, \00302,00$nick\00303,00! [\00302,00$secs\00303,00 sec \00302,00$cps\00303,00 cps]");
	    if ($cps >= 5)
	    {
		$conn -> privmsg ($conn -> {channel}, "\00312,00Amazing typing speed for \00304,00$nick\00312,00 with \00304,00$cps\00312,00 cps!");
	    }
	    if ($secs < 1)
	    {
		$conn -> privmsg ($conn -> {channel}, "\00312,00Very fast answer by \00304,00$nick\00312,00 with \00304,00$secs\00312,00 seconds!");
	    }
	    $init_time2 = time;
	    $elapsed2 = $init_time2;
	    $status = 'answered';
	    $answered = 1;
	}
    }
}

$conn -> add_handler ('public', \&on_public);

while (1)
{
    main_loop ($conn);
    loop_msgs ($conn);
    loop_hints ($conn);
    $irc -> do_one_loop ();
}

$irc -> start ();

# count how many questions (lines) are there in the questions.txt file
sub count_lines
{
    $val_open = open (QF, "questions.txt");
    if ($val_open == 1)
    {
	$lines = 0;
	while (<QF>)
	{
	    $lines = $lines + 1;
	}
    }
    close (QF);
    return $lines;		# return the number of lines found
}

sub get_cfg
{
    $val_open = open (CFG, "xptblite.cfg");
    if ($val_open == 1)
    {
	while (<CFG>)
	{
	    @array = split ('=', $_);
	    $opt = $array[0];
	    $val = $array[1];
	    chop ($val);
	    if ($opt =~ /^server$/)
	    {
		$glob_server = $val;
	    }
	    elsif ($opt =~ /^port$/)
	    {
		$glob_port = $val;
	    }
	    elsif ($opt =~ /^nick$/)
	    {
		$glob_nick = $val;
	    }
	    elsif ($opt =~ /^ircname$/)
	    {
		$glob_ircname = $val;
	    }
	    elsif ($opt =~ /^username$/)
	    {
		$glob_username = $val;
	    }
	    elsif ($opt =~ /^channel$/)
	    {
		$glob_channel = $val;
	    }
	}
    }
    close (CFG);
}

sub loop_msgs
{
    my $conn = shift;
    $msgs_time_now = time;
    $diff_msgs = $msgs_time_now - $time_of_msgs;
    if ($diff_msgs == 600)    # show an info message every 600 seconds
    {
	if ($count_msgs == 0)
	{
	    $conn->privmsg ($conn -> {channel}, "\00300,03XPTB Lite 0.2.4 by Craciun Dan - Visit the homepage at http://www.tuxarena.com/intro/xptb.php for new releases.");
	    $time_of_msgs = time;
	    $count_msgs = $count_msgs + 1;
	}
	elsif ($count_msgs == 1)
	{
	    $conn->privmsg ($conn -> {channel}, "\00300,03There are $lines questions available.");
	    $time_of_msgs = time;
	    $count_msgs = $count_msgs + 1;
	}
	elsif ($count_msgs == 2)
	{
	    $conn -> privmsg ($conn -> {channel}, "\00300,03Available commands: !TRIVIA, !VERSION, !QUESTIONS, !DATE");
	    $time_of_msgs = time;
	    $count_msgs = 0;
	}
    }
}

sub loop_hints
{
    my $conn = shift;
    $time_now_hints = time;
    $diff_hints = $time_now_hints - $time_last_hint;
    if ($diff_hints == 8)
    {
	if ($hint_a)
	{
	    if ($hint_b)
	    {
		if ($answered == 0)
		{
		    $conn -> privmsg ($conn -> {channel}, "\00302,00Hint 2:\00304,00 $hint_b");
		}
	    }
	}
    }
}

sub show_date
{
    my $conn = shift;
    $var_date = `date +"%b %d, %Y %H:%M:%S"`;
    return $var_date;
#    $conn -> privmsg ($conn -> {channel}, "\00303,00Current system date and time: $var_date");
}
